#
#-##########################################################
#
# EDITS:
#
# 04/27/16 [htruax]: Changed file_read_button.bind( ) to look for '# ***** Calculations *****' as an indicator to stop
# reading '# ***** Field Data *****' boxes. The '# ***** Field Data *****' section has been moved from just before the
# Profiles to just after them.
#
#-##########################################################
#

require 'tk'

# Window drawing section.

root = TkRoot.new() { title "BOX RE-NUMBER / CODE REPLICATION" }
root.geometry('+15+60')

top_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x")

file_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "padx" =>10, "pady" =>10)
file_label = TkLabel.new(file_frame, :text=>"File Name", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:fill=>:x)

file_text = TkVariable.new
file_entry = TkEntry.new(file_frame, :textvariable=>file_text, "font"=>"arial 10").pack()

file_read_button = TkButton.new(file_frame, :text=>"Read File", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack("pady" => 5)

exit_button = TkButton.new(file_frame, :width=>6, :foreground=>"red", :text=>"Exit", :background=>"lightgrey", "font"=>"arial 10").pack(:pady=>5)

boxes_offsets_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack(:anchor=>"n", :side=>"left", :pady =>10, :padx=>5 )

boxes_frame = TkFrame.new(boxes_offsets_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :padx=>5, :pady=>5)

first_box_frame = TkFrame.new(boxes_frame).pack(:side=>"top", :pady=>5)

first_button = TkButton.new(first_box_frame, :width=>10, :text=>"First Box", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:side=>"left", :padx=>5)

first_box = TkVariable.new

second_box_frame = TkFrame.new(boxes_frame).pack(:side=>"top")

first_entry = TkEntry.new(second_box_frame, :textvariable=>first_box, :width=>12, "font"=>"arial 10").pack(:side=>"left", :padx=>5)

offsets_frame = TkFrame.new(boxes_offsets_frame, :borderwidth=>3, :relief=>:ridge).pack("side"=>"top", "padx" =>5, "pady" =>5)

first_offset_frame = TkFrame.new(offsets_frame).pack(:side=>"top", :pady=>7)

page_offset_label = TkLabel.new(first_offset_frame, :text=>"Page Offset", :relief=>:sunken, :background=>"lightgrey", :width=>10, "font"=>"arial 10").pack(:side=>"left", :padx=>5)

second_offset_frame = TkFrame.new(offsets_frame).pack("side"=>"top")

page_offset = TkVariable.new
page_offset_entry = TkEntry.new(second_offset_frame, :textvariable=>page_offset, :width=>10, "font"=>"arial 10").pack(:side=>"left", :padx=>5, :pady=>5)

last_button = TkButton.new(first_box_frame, :width=>10, :text=>"Last Box", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:padx=>5, :side=>"left")

last_box = TkVariable.new
last_entry = TkEntry.new(second_box_frame, :textvariable=>last_box, :width=>12, "font"=>"arial 10").pack(:side=>"left", :padx=>5, :pady=>5)

box_offset_label = TkLabel.new(first_offset_frame, :text=>"Box Offset", :relief=>:sunken, :background=>"lightgrey", :width=>10, "font"=>"arial 10").pack(:side=>"left", :padx=>5)

# Cindy version:
#~ box_offset = TkVariable.new(1)
box_offset = TkVariable.new()
box_offset_entry = TkEntry.new(second_offset_frame, :textvariable=>box_offset, :width=>10, "font"=>"arial 10").pack(:side=>"left", :padx=>5)

clear_boxes_button = TkButton.new(boxes_frame, :width=>10, :text=>"Clear Boxes", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:padx=>25, :pady=>5, :side=>"left")

clear_boxes_toggle_button = TkButton.new(boxes_frame, :width=>3, :text=>"OFF", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>5, :side=>"left")

clear_offsets_button = TkButton.new(offsets_frame, :width=>10, :text=>"Clear Offsets", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:padx=>17, :pady=>7, :side=>"left")

clear_offsets_toggle_button = TkButton.new(offsets_frame, :width=>3, :text=>"OFF", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack(:pady=>7, :side=>"left")

exclusion_box_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack("anchor"=>"n", "side"=>"left", "pady"=>10, :padx=>5)
exclusion_button = TkButton.new(exclusion_box_frame, :background=>"lightgrey", :foreground=>"blue", :text=>"Exclusion Boxes", "font"=>"arial 10").pack(:pady=>5)

exclusion_text_frame = TkFrame.new(exclusion_box_frame).pack("side"=>"top", :pady=>3, :padx=>5)
exclusion_box_bar_vert = TkScrollbar.new(exclusion_text_frame).pack("side"=>"right", "fill"=>"y")
exclusion_box_text = TkText.new(exclusion_text_frame, "wrap"=>"none", "width"=>15, "height"=>6, "font"=>"arial 10").pack("side"=>"left")
exclusion_box_text.yscrollbar(exclusion_box_bar_vert)

clear_exclusion_button = TkButton.new(exclusion_box_frame, :background=>"lightgrey", :foreground=>"blue", :text=> "Clear List", "font"=>"arial 10", "font"=>"arial 10").pack(:pady=>5)

box_list_frame = TkFrame.new(top_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :pady=>10, :padx=>10)
box_list_label = TkLabel.new(box_list_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Box List", "font"=>"arial 10").pack(:fill=>:x)

box_select_frame = TkFrame.new(box_list_frame).pack(:side=>"bottom", "pady" => 5)
box_select_button = TkButton.new(box_select_frame, :background=>"lightgrey", :foreground=>"blue", :text=>"Select Single", "font"=>"arial 10").pack(:side=>"right")

adj_frame = TkFrame.new(box_list_frame).pack("anchor"=>"w", "side"=>"right", "padx" =>10, "pady" =>27)

box_list_bar_vertical = TkScrollbar.new(box_list_frame).pack(:side=>"right", :fill=>"y")
box_list = TkListbox.new(box_list_frame, "background"=>"white", "exportselection" => 0, "width"=>17, "height"=>11, :selectmode=>"extended", "font"=>"arial 10").pack("side"=>"left")
box_list.yscrollbar(box_list_bar_vertical)

adj_page_button = TkButton.new(adj_frame, "width"=>5, :background=>"lightgrey", :foreground=>"blue", :text=> "Page", "font"=>"arial 10").pack("pady" => 10)

adj_box_button = TkButton.new(adj_frame, "width"=>5, :background=>"lightgrey", :foreground=>"blue", :text=>"Box", "font"=>"arial 10").pack()

reset_button = TkButton.new(adj_frame, "width"=>5, :background=>"lightgrey", :foreground=>"blue", :text=>"Reset", "font"=>"arial 10").pack("pady" => 10)

renumber_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x", :pady =>5)

renumber_button_frame = TkFrame.new(renumber_frame).pack("side"=>"left", "padx"=>10)
renumber_button = TkButton.new(renumber_button_frame, :text=>"Re-Number Input Code", "width"=>18, :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack()

clear_input_button_frame = TkFrame.new(renumber_frame).pack("side"=>"left")
clear_input_button = TkButton.new(clear_input_button_frame, "width"=>18, :text=>"Delete Input Code", :background=>"lightgrey", :foreground=>"blue", "font"=>"arial 10").pack()

get_boxes_button_frame = TkFrame.new(renumber_frame).pack("side"=>"left", "padx"=>10)
get_boxes_button = TkButton.new(get_boxes_button_frame, "width"=>18, :background=>"lightgrey", :foreground=>"blue", :text=>"Create Box List", "font"=>"arial 10").pack()

delete_box_list_button_frame = TkFrame.new(renumber_frame).pack("side"=>"left")
delete_box_list_button = TkButton.new(delete_box_list_button_frame, "width"=>18, :background=>"lightgrey", :foreground=>"blue", :text=>"Delete Box List", "font"=>"arial 10").pack()

reps_frame = TkFrame.new(renumber_frame, :borderwidth=>3, :relief=>:ridge).pack(:side=>"left", :padx =>10)

num_reps_label = TkLabel.new(reps_frame, :text=>"Repetitions", :relief=>:sunken, :background=>"lightgrey", "font"=>"arial 10").pack(:side=>"left")

num_reps = TkVariable.new
num_reps_entry = TkEntry.new(reps_frame, :textvariable=>num_reps, :width=>3, "font"=>"arial 10").pack(:side=>"left")
num_reps.value = "1"

input_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"both", "expand"=>true)

in_text_frame = TkFrame.new(input_frame).pack("side"=>"left", "fill"=>"both", "padx"=>10, "expand"=>true)
in_text_bar_vert = TkScrollbar.new(in_text_frame).pack("side"=>"right", "fill"=>"y")
in_text = TkText.new(in_text_frame, "width"=>113, "height"=>15, "font"=>"arial 10").pack("side"=>"bottom", "fill"=>"both", "expand"=>true)

in_text.yscrollbar(in_text_bar_vert)

in_text.focus

output_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"both", "expand"=>true)

output_label_frame = TkFrame.new(output_frame).pack("side"=>"top")
output_label = TkLabel.new(output_label_frame, :relief=>:sunken, :background=>"lightgrey", :text=>"Output Code - Input Code Re-Numbered - NOTE: ' Ctrl-/ ' selects all text.", "font"=>"arial 10").pack()

out_text_frame = TkFrame.new(output_frame).pack("side"=>"left", "padx" => 10, "fill"=>"both", "expand"=>true)
out_text_bar_vert = TkScrollbar.new(out_text_frame).pack("side"=>"right", "fill"=>"y")
out_text = TkText.new(out_text_frame,"width"=>113, "height"=>15, "font"=>"arial 10").pack("side"=>"bottom", "fill"=>"both", "expand"=>true)

out_text.yscrollbar(out_text_bar_vert)

bottom_frame = TkFrame.new(root).pack("side"=>"top", "fill"=>"x", "pady" => 5)

# Action section.

box_array = Array.new

file_read_button.bind("Button-1") {
  
	src_path = "C:/temp/"
	src_file_name = file_text.to_s
	source = src_path + src_file_name
	
	File.open(source, "r") do |src_file|

		box_list.delete(0, "end")
		box_array.clear

		#while ((line = src_file.gets) and (line !~ /\*+\s*Profile Classes\s*\*+/))
		while ((line = src_file.gets) and (line !~ /\*+\s*Calculations\s*\*+/))
			if (line =~ /(\Abox\d+_\d+)/) then box_array.insert(-1, $1) end
		end

		box_array.each { |x| box_list.insert('end', x) }
	end

	# Select (show highlighting) first list element.
	box_list.selection_set(0)
}

first_button.bind("Button-1") {
	#~ first_box.value = box_list.get("active")
	box_list.get("active").scan(/box\d+_\d+/) { |box|
		first_box.value = box
	}
}

last_button.bind("Button-1") {
	#~ last_box.value = box_list.get("active")
	box_list.get("active").scan(/box\d+_\d+/) { |box|
		last_box.value = box
	}
}

exclusion_button.bind("Button-1") {
	#~ box_text = box_list.get("active")
	#~ exclusion_box_text.insert("end", box_text + "\n") if (!box_text.empty?)
	box_indices_array = Array.new
	exclusion_box_array = Array.new

	exclusion_box_array = exclusion_box_text.get("1.0", "end").scan(/box\d+_\d+/)

	box_indices_array = box_list.curselection

	box_indices_array.each { |x|
		box_list.get(x).scan(/box\d+_\d+/) { |box|
			exclusion_box_text.insert("end", box + "\n") unless exclusion_box_array.include?(box)
		}
	}

	# Now sort the list and redisplay it.
	exclusion_box_array.clear
	exclusion_box_text.get("1.0", "end").scan(/(box)(\d+)(_)(\d+)/) {
		exclusion_box_array.push([$2.to_i,$4.to_i])
	}

	exclusion_box_array.sort!
	exclusion_box_text.delete("1.0", "end")

	exclusion_box_array.each_index { |index|
		exclusion_box_text.insert("end", "box#{exclusion_box_array[index][0]}_#{exclusion_box_array[index][1]}\n")
	}
}

box_select_button.bind("Button-1") {

	# Determine the current selectmode configuration, it will be either "browse", only one item
	# selectable at a time, or "multiple", where more than one item at a time can be selected.
	# Switch configuration between the two: "browse" or "multiple".
	#
	case box_list.cget("selectmode")

		when "extended"

			box_list.configure("selectmode", "multiple")
			box_select_button.configure("text", "Select Multiple")

		#~ when "browse"

			#~ box_list.configure("selectmode", "multiple")
			#~ box_select_button.configure("foreground", "blue")

		when "multiple"

			# User can select (highlight) multiple list elements at once.
			box_list.configure("selectmode", "extended")
			box_select_button.configure("text", "Select Single")

			# Clear all selected elements, then select (highlight) the last element selected,
			# which is the currently 'active' element - the last one clicked on.
			box_list.selection_clear(0, "end")
			box_list.selection_set(box_list.index("active"))

		#~ when "multiple"
			#~ # User can select (highlight) multiple list elements at once.

			#~ box_list.configure("selectmode", "browse")
			#~ box_select_button.configure("foreground", "black")

			#~ # Clear all selected elements, then select (highlight) the last element selected,
			#~ # which is the currently 'active' element - the last one clicked on.
			#~ box_list.selection_clear(0, "end")
			#~ box_list.selection_set(box_list.index("active"))
	end
}

adj_page_button.bind("Button-1") {

	# Each box can have it's own page number adjustment.
	box_indices_array = Array.new
	box = String.new

	box_indices_array = box_list.curselection
	box_indices_array.each { |x|
		box = box_list.get(x).sub(/(box)(\d+)(_)(\d+)(    )?(-?\d+|P)?(  )?(-?\d+|B)?/) {
			$1+$2+$3+$4+"    #{page_offset.value.to_i.to_s}"+($7 == nil ? "  " : $7)+($8 == nil ? "B" : $8)
			}
		box_list.delete(x)
		box_list.insert(x, box)
		box_list.selection_set(x)
		box_list.activate(x)
	}
}

adj_box_button.bind("Button-1") {

	# Each box can have it's own box number adjustment.
	box_indices_array = Array.new
	box = String.new

	box_indices_array = box_list.curselection
	box_indices_array.each { |x|
		box = box_list.get(x).sub(/(box)(\d+)(_)(\d+)(    )?(-?\d+|P)?(  )?(-?\d+|B)?/) {
			$1+$2+$3+$4+($5 == nil ? "    " : $5)+($6 == nil ? "P" : $6)+"  #{box_offset.value.to_i.to_s}"
			}
		box_list.delete(x)
		box_list.insert(x, box)
		box_list.selection_set(x)
		box_list.activate(x)
	}
}

reset_button.bind("Button-1") {

	# Reset the selected box(es) to just the box portion - ex. 'box1_1'.
	box_indices_array = Array.new
	box = String.new

	box_indices_array = box_list.curselection
	box_indices_array.each { |x|
		box = box_list.get(x).sub(/(box\d+_\d+)(    )?(-?\d+|P)?(  )?(-?\d+|B)?/) { $1 }
		box_list.delete(x)
		box_list.insert(x, box)
		box_list.selection_set(x)
		box_list.activate(x)
	}
}

clear_exclusion_button.bind("Button-1") { exclusion_box_text.delete("1.0", "end") }

clear_input_button.bind("Button-1") {

	in_text.delete("1.0", "end")

	# Also default to a "clean state" - ready for the next renumbering episode.
	box_list.delete(0, "end")
	exclusion_box_text.delete("1.0", "end")
	page_offset.value = ''

	# Cindy's version - set this to '' for others.
	#~ box_offset.value = 1
	box_offset.value = ''

	num_reps.value = 1
	first_box.value = ''
	last_box.value = ''

	# Set the focus to the input text window, and put the cursor at the first char on line one.
	in_text.focus
	in_text.mark_set('insert', '1.0')
	}

clear_boxes_button.bind("Button-1") {

	first_box.value = ''
	last_box.value = ''
	}

clear_boxes_toggle_button.bind("Button-1") {

	#
	# User can toggle this "ON/OFF" - clears the First/Last box values when the renumber button is selected.
	#
	case clear_boxes_toggle_button.cget("text")

		when "OFF" then clear_boxes_toggle_button.configure("text", "ON")
		when "ON" then clear_boxes_toggle_button.configure("text", "OFF")
	end
	}

clear_offsets_button.bind("Button-1") {

	page_offset.value = ''
	box_offset.value = ''
	}

clear_offsets_toggle_button.bind("Button-1") {

	#
	# User can toggle this "ON/OFF" - clears the Page/Box offset values when the renumber button is selected.
	#
	case clear_offsets_toggle_button.cget("text")

		when "OFF" then clear_offsets_toggle_button.configure("text", "ON")
		when "ON" then clear_offsets_toggle_button.configure("text", "OFF")
	end
	}

exit_button.bind("Button-1") { exit(0) }

renumber_button.bind("Button-1") {

	page_num_array = Array.new
	exclusion_box_array = Array.new
	box_page_num_array = Array.new
	box_array = Array.new

	box = String.new
	input_str = String.new

	#
	# Check if we are to clear the First/Last Box and Page/Box Offsets values:
	if (clear_boxes_toggle_button.cget("text") == "ON")

		first_box.value = ''
		last_box.value = ''
	end

	if (clear_offsets_toggle_button.cget("text") == "ON")

		page_offset.value = ''
		box_offset.value = ''
	end

	out_text.delete("1.0", "end")
	input_str = in_text.get("1.0", "end")

	# These are the global adjust amounts, used if a particular box does not have it's own values.
	box_adjust = box_offset.to_s.to_i
	page_adjust = page_offset.to_s.to_i

	box_array = box_list.get(0, "end")
	
	box_array.each_index { |index|
		if (box_array[index] =~ /(box\d+_\d+)(    )?(-?\d+|P)?(  )?(-?\d+|B)?/)
			box_array[index] = $1
			page_adj = if ($3 != nil)
						($3 == "P" ? page_adjust : $3.to_i)
					else
						page_adjust
					end
			box_adj = if ($5 != nil)
						($5 == "B" ? box_adjust : $5.to_i)
					else
						box_adjust
					end
			box_page_num_array.push([page_adj, box_adj])
		end
	}

	if (first_box.to_s =~ /(box)(\d+)(_)(\d+)/)
		first_page = $2.to_i
		first_num = $4.to_i
	else
		first_page = 0
		first_num = 0
	end

	if (last_box.to_s =~ /(box)(\d+)(_)(\d+)/)
		last_page = $2.to_i
		last_num = $4.to_i
	else
		last_page = 0
		last_num = 0
	end

	# If both first_box and last_box are empty, run using the boxes in the input text. A sorted list will be
	# generated and the values will come from the top and bottom as first, and last, respectively.
	if ((first_page + first_num + last_page + last_num) == 0)

		input_str.each { |code_line|
			code_line.scan(/(box)(\d+)(_)(\d+)/) {
				page_num_array.push([$2.to_i,$4.to_i]) unless page_num_array.include?([$2.to_i,$4.to_i])
			}
		}

		# Now sort the two-dimensional page_num_array.
		page_num_array.sort!
	
		# Now convert the first pair of values to first_page/first_num values and the last pair to last_page/last/num values,
		# in place of user entered. IF the input_str is empty, use the default 0 values, which changes nothing.
		if (page_num_array.size > 0)
			first_page = page_num_array[0][0]
			first_num = page_num_array[0][1]
			last_page = page_num_array[page_num_array.size - 1][0]
			last_num = page_num_array[page_num_array.size - 1][1]
		end
	end
	
	exclusion_box_array = exclusion_box_text.get("1.0", "end").scan(/box\d+_\d+/)

	1.upto(num_reps.value.to_i) { |x|
		input_str.each { |code_line|

			code_line.gsub!(/(box)(\d+)(_)(\d+)/) { |box|

				page = $2.to_i
				num = $4.to_i

				# Adjust the page and box numbers if the box is not in the exclusion list.
				if (!exclusion_box_array.include?(box))

					adjust = false

					# First check that we are in the page range.
					if ((first_page..last_page) === page)
						if (first_page == last_page)
							# All we need to do is make sure the box num is in the correct range.
							if ((first_num..last_num) === num) then adjust = true end
						else
							# Our box range covers more than one page, need to check if our current
							# box is on the first or last page of the range.
							if (page == first_page)
								if (num >= first_num) then adjust = true end
							elsif (page == last_page)
								if (num <= last_num) then adjust = true end
							else adjust = true
							end
						end

						if (adjust)
							if (box_array.length > 0)
#~ out_text.insert("end", box_list_array[box_list_array.index(box)])

								page += box_page_num_array[box_array.index(box)][0] * x
								num += box_page_num_array[box_array.index(box)][1] * x
							else
								page += page_adjust * x
								num += box_adjust * x
							end
						end
					end
				end

				# Prepare the box token for re-insertion back into the string.
				$1 + page.to_s + $3 + num.to_s
			}
			out_text.insert("end", code_line)
		}
	}
	out_text.focus
	out_text.mark_set("insert", "1.0")
}

get_boxes_button.bind("Button-1") {

	page_num_array = Array.new
	box = String.new
	input_str = String.new

	# Clear the Box List.
	box_list.delete(0, "end")

	# Get input code.
	input_str = in_text.get("1.0", "end")

	input_str.each { |code_line|
		code_line.scan(/(box)(\d+)(_)(\d+)/) {
			page_num_array.push([$2.to_i,$4.to_i]) unless page_num_array.include?([$2.to_i,$4.to_i])
		}
	}

	# Now sort the two-dimensional page_num_array.
	page_num_array.sort!

	# Now put the box parts back together and insert into the Box List widget.
	page_num_array.each_index { |index|
		box_list.insert("end", "box#{page_num_array[index][0]}_#{page_num_array[index][1]}")
	}

	# Select (show highlighting) first list element.
	box_list.selection_set(0)
}

delete_box_list_button.bind("Button-1") { box_list.delete(0, "end") }

Tk.mainloop()
